//
//  RootViewController.m
//  MadLib
//
//  Created by ernesto on 02/12/12.
//  Copyright (c) 2012 raywenderlich. All rights reserved.
//

#import "RootViewController.h"

@interface RootViewController ()
@property (weak) IBOutlet NSTextField *pastTenseVerbTextField;
@property (weak) IBOutlet NSComboBox *singularNounCombo;
@property (nonatomic,strong) NSArray *singularNouns;
@property (weak) IBOutlet NSPopUpButton *pluralNounPopup;
@property (nonatomic,strong) NSArray *pluralNouns;
@property (unsafe_unretained) IBOutlet NSTextView *phraseTextView;
@property (weak) IBOutlet NSTextField *amountLabel;
@property (weak) IBOutlet NSSlider *amountSlider;
@property (weak) IBOutlet NSDatePicker *datePicker;
@property (weak) IBOutlet NSMatrix *placeRadioButton;
@property (weak) IBOutlet NSButton *yellCheck;
@property (weak) IBOutlet NSTextFieldCell *resultTextField;
@property (weak) IBOutlet NSImageView *imageView;

@end

@implementation RootViewController
- (IBAction)sliderChanged:(id)sender {
    
    NSInteger amount = [self.amountSlider integerValue];
    NSString *amountString = [NSString stringWithFormat:@"Amount [%ld]", amount];
    [self.amountLabel setStringValue:amountString];
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}
- (IBAction)goButton:(id)sender {
    
    // Past tense verb
    NSString *pastTenseVerb = [self.pastTenseVerbTextField stringValue];
    
    // Singular
    NSString *singularNoun = [self.singularNounCombo stringValue];
    
    
    // Place
    NSString *placeString;
    NSInteger row = [self.placeRadioButton selectedRow];
    if( row == 0)
        placeString = @"WWDC";
    else if( row==1)
        placeString = @"360iDev";
    
    // Amount
    NSInteger amount = [self.amountSlider integerValue];
    
    // Plural noun
    NSString *pluralNoum = @"";
    NSInteger selectedIndex = [self.pluralNounPopup indexOfSelectedItem];
    pluralNoum = self.pluralNouns[selectedIndex];
    
    // Phrase
    NSString *phrase;
    phrase = [self.phraseTextView string];
    
    // Date
    NSString *date =@" ";
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateStyle:NSDateFormatterLongStyle];
    date = [dateFormatter stringFromDate:[self.datePicker dateValue]];
    
    // Yell!!
    NSString *voice = @"said";
    if( self.yellCheck.state == NSOnState)
        voice = @"yelled";
    // Create the results string
    NSString *results = [NSString stringWithFormat:
                         @"On %@, at %@ a %@ %@ %@ %@ and %@, %@!",
                         date,
                         placeString,
                         singularNoun,
                         pastTenseVerb,
                         @(amount),
                         pluralNoum,
                         voice,
                         phrase];
    // Set results
    [self.resultTextField setStringValue:results];
    
    // Load image
    self.imageView.image = [NSImage imageNamed:@"face.png"];
}

-(void)awakeFromNib
{
    NSLog(@"View controller instance with view: %@", self.view);
    // Set the pastTenseVerb initial value
    [self.pastTenseVerbTextField setStringValue:@"ate"];
    // Setup combo box with singular nouns
    self.singularNouns = @[@"dog", @"muppet", @"ninja", @"fat dude"];
    [self.singularNounCombo addItemsWithObjectValues:self.singularNouns];
    [self.singularNounCombo selectItemAtIndex:2];
    // Setup popup menu with pluralNouns
    self.pluralNouns  = @[@"tacos", @"rainbows", @"iPhones", @"gold coins"];
    [self.pluralNounPopup removeAllItems];
    [self.pluralNounPopup addItemsWithTitles:self.pluralNouns];
    [self.pluralNounPopup selectItemAtIndex:0];

    // Set textView initial text
    [self.phraseTextView setString:@"Me coding Mac Apps!!!"];
    
    [self sliderChanged:self];
    // Setup date
    [self.datePicker setDateValue:[NSDate date]];
    // Update the radio buttons selection
    [self.placeRadioButton selectCellAtRow:1 column:0];

    // set check button state
    self.yellCheck.state = NSOffState;
}


@end
